/* worm.c generated by valac 0.55.1, the Vala compiler
 * generated from worm.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <gee.h>

#define WORM_STARTING_LIVES ((guint8) 6)
#define WORM_STARTING_LENGTH 5
#define WORM_MAX_LIVES ((guint8) 12)
#define WORM_GROW_FACTOR 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WORMCHAR 'w'
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;
typedef struct _WormPropertiesPrivate WormPropertiesPrivate;
enum  {
	WORM_PROPERTIES_0_PROPERTY,
	WORM_PROPERTIES_COLOR_PROPERTY,
	WORM_PROPERTIES_UP_PROPERTY,
	WORM_PROPERTIES_DOWN_PROPERTY,
	WORM_PROPERTIES_LEFT_PROPERTY,
	WORM_PROPERTIES_RIGHT_PROPERTY,
	WORM_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* worm_properties_properties[WORM_PROPERTIES_NUM_PROPERTIES];

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;
typedef struct _WormPrivate WormPrivate;
enum  {
	WORM_0_PROPERTY,
	WORM_STARTING_POSITION_PROPERTY,
	WORM_ID_PROPERTY,
	WORM_IS_MATERIALIZED_PROPERTY,
	WORM_LIVES_PROPERTY,
	WORM_CHANGE_PROPERTY,
	WORM_SCORE_PROPERTY,
	WORM_LENGTH_PROPERTY,
	WORM_HEAD_PROPERTY,
	WORM_DIRECTION_PROPERTY,
	WORM_LIST_PROPERTY,
	WORM_WIDTH_PROPERTY,
	WORM_HEIGHT_PROPERTY,
	WORM_CAPACITY_PROPERTY,
	WORM_NUM_PROPERTIES
};
static GParamSpec* worm_properties[WORM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _position_free0(var) ((var == NULL) ? NULL : (var = (position_free (var), NULL)))
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
enum  {
	WORM_ADDED_SIGNAL,
	WORM_FINISH_ADDED_SIGNAL,
	WORM_MOVED_SIGNAL,
	WORM_RESCALED_SIGNAL,
	WORM_DIED_SIGNAL,
	WORM_TAIL_REDUCED_SIGNAL,
	WORM_REVERSED_SIGNAL,
	WORM_BONUS_FOUND_SIGNAL,
	WORM_NUM_SIGNALS
};
static guint worm_signals[WORM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Position {
	guint8 x;
	guint8 y;
};

struct _WormProperties {
	GObject parent_instance;
	WormPropertiesPrivate * priv;
};

struct _WormPropertiesClass {
	GObjectClass parent_class;
};

struct _WormPropertiesPrivate {
	gint _color;
	guint _up;
	guint _down;
	guint _left;
	guint _right;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gboolean is_stopped;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _WormPrivate {
	Position _starting_position;
	gint _id;
	gboolean _is_materialized;
	gint rounds_dematerialized;
	guint8 _lives;
	gint _change;
	gint _score;
	WormDirection _direction;
	WormDirection starting_direction;
	GeeArrayQueue* key_queue;
	GeeLinkedList* _list;
	guint8 _width;
	guint8 _height;
	gint _capacity;
};

static gint WormProperties_private_offset;
static gpointer worm_properties_parent_class = NULL;
static gint Worm_private_offset;
static gpointer worm_parent_class = NULL;
static guint* worm_deadend_board;
static gint worm_deadend_board_length1;
static gint worm_deadend_board_length2;
static guint* worm_deadend_board = NULL;
static gint worm_deadend_board_length1 = 0;
static gint worm_deadend_board_length2 = 0;
static guint worm_deadend_runnumber;
static guint worm_deadend_runnumber = (guint) 0;

VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN WormDirection worm_direction_opposite (WormDirection self);
VALA_EXTERN WormDirection worm_direction_turn_left (WormDirection self);
VALA_EXTERN WormDirection worm_direction_turn_right (WormDirection self);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN void position_move (Position *self,
                    WormDirection direction,
                    guint8 width,
                    guint8 height);
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_properties_get_color (WormProperties* self);
VALA_EXTERN void worm_properties_set_color (WormProperties* self,
                                gint value);
VALA_EXTERN guint worm_properties_get_up (WormProperties* self);
VALA_EXTERN void worm_properties_set_up (WormProperties* self,
                             guint value);
VALA_EXTERN guint worm_properties_get_down (WormProperties* self);
VALA_EXTERN void worm_properties_set_down (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_left (WormProperties* self);
VALA_EXTERN void worm_properties_set_left (WormProperties* self,
                               guint value);
VALA_EXTERN guint worm_properties_get_right (WormProperties* self);
VALA_EXTERN void worm_properties_set_right (WormProperties* self,
                                guint value);
static void worm_properties_finalize (GObject * obj);
static GType worm_properties_get_type_once (void);
static void _vala_worm_properties_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_worm_properties_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height);
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN GeeLinkedList* worm_get_list (Worm* self);
static void worm_set_starting_position (Worm* self,
                                 Position * value);
VALA_EXTERN void worm_get_starting_position (Worm* self,
                                 Position * result);
static void worm_set_direction (Worm* self,
                         WormDirection value);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN void worm_move_part_1 (Worm* self);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
static guint8 worm_get_width (Worm* self);
static guint8 worm_get_height (Worm* self);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
static void worm_set_head (Worm* self,
                    Position * value);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN gboolean worm_get_is_materialized (Worm* self);
VALA_EXTERN gint worm_get_id (Worm* self);
static void worm_dequeue_keypress (Worm* self);
static void worm_materialize (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       gint erase_size);
VALA_EXTERN void worm_reverse (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2);
static void worm_set_list (Worm* self,
                    GeeLinkedList* value);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           gint numworms,
                           Position* position);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void worm_set_is_materialized (Worm* self,
                               gboolean value);
VALA_EXTERN void worm_dematerialize (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint rounds,
                         gint gamedelay);
static gboolean __lambda4_ (Worm* self);
static gboolean ___lambda4__gsource_func (gpointer self);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_set_lives (Worm* self,
                     guint8 value);
static inline void worm_lose_life (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
static void worm_direction_set (Worm* self,
                         WormDirection dir);
static void worm_queue_keypress (Worm* self,
                          WormDirection dir);
static guint worm_upper_key (Worm* self,
                      guint keyval);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keyval,
                               GeeHashMap* worm_props);
static gint worm_ai_deadend (gint* board,
                      gint board_length1,
                      gint board_length2,
                      gint numworms,
                      Position* old_position,
                      gint length_left);
static gint worm_ai_deadend_after (gint* board,
                            gint board_length1,
                            gint board_length2,
                            GeeLinkedList* worms,
                            gint numworms,
                            Position* old_position,
                            WormDirection direction,
                            gint length);
static inline gboolean worm_ai_too_close (Worm* self,
                            GeeLinkedList* worms);
static gboolean worm_ai_wander (gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint numworms,
                         Position* updated_position,
                         WormDirection direction,
                         Position* initial_position);
VALA_EXTERN GType bonus_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   gint numworms,
                   GeeLinkedList* worms);
static gint worm_get_capacity (Worm* self);
VALA_EXTERN gint worm_get_length (Worm* self);
static gboolean _position_equal (const Position * s1,
                          const Position * s2);
static void worm_set_id (Worm* self,
                  gint value);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
static void worm_set_width (Worm* self,
                     guint8 value);
static void worm_set_height (Worm* self,
                      guint8 value);
static void worm_set_capacity (Worm* self,
                        gint value);
static GObject * worm_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties);
static void worm_finalize (GObject * obj);
static GType worm_get_type_once (void);
static void _vala_worm_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_worm_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

WormDirection
worm_direction_opposite (WormDirection self)
{
	WormDirection result;
	switch (self) {
		case WORM_DIRECTION_RIGHT:
		{
			result = WORM_DIRECTION_LEFT;
			return result;
		}
		case WORM_DIRECTION_LEFT:
		{
			result = WORM_DIRECTION_RIGHT;
			return result;
		}
		case WORM_DIRECTION_DOWN:
		{
			result = WORM_DIRECTION_UP;
			return result;
		}
		case WORM_DIRECTION_UP:
		{
			result = WORM_DIRECTION_DOWN;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

WormDirection
worm_direction_turn_left (WormDirection self)
{
	WormDirection result;
	switch (self) {
		case WORM_DIRECTION_RIGHT:
		{
			result = WORM_DIRECTION_UP;
			return result;
		}
		case WORM_DIRECTION_UP:
		{
			result = WORM_DIRECTION_LEFT;
			return result;
		}
		case WORM_DIRECTION_LEFT:
		{
			result = WORM_DIRECTION_DOWN;
			return result;
		}
		case WORM_DIRECTION_DOWN:
		{
			result = WORM_DIRECTION_RIGHT;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

WormDirection
worm_direction_turn_right (WormDirection self)
{
	WormDirection result;
	switch (self) {
		case WORM_DIRECTION_RIGHT:
		{
			result = WORM_DIRECTION_DOWN;
			return result;
		}
		case WORM_DIRECTION_DOWN:
		{
			result = WORM_DIRECTION_LEFT;
			return result;
		}
		case WORM_DIRECTION_LEFT:
		{
			result = WORM_DIRECTION_UP;
			return result;
		}
		case WORM_DIRECTION_UP:
		{
			result = WORM_DIRECTION_RIGHT;
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

static GType
worm_direction_get_type_once (void)
{
	static const GEnumValue values[] = {{WORM_DIRECTION_NONE, "WORM_DIRECTION_NONE", "none"}, {WORM_DIRECTION_RIGHT, "WORM_DIRECTION_RIGHT", "right"}, {WORM_DIRECTION_DOWN, "WORM_DIRECTION_DOWN", "down"}, {WORM_DIRECTION_LEFT, "WORM_DIRECTION_LEFT", "left"}, {WORM_DIRECTION_UP, "WORM_DIRECTION_UP", "up"}, {0, NULL, NULL}};
	GType worm_direction_type_id;
	worm_direction_type_id = g_enum_register_static ("WormDirection", values);
	return worm_direction_type_id;
}

GType
worm_direction_get_type (void)
{
	static volatile gsize worm_direction_type_id__once = 0;
	if (g_once_init_enter (&worm_direction_type_id__once)) {
		GType worm_direction_type_id;
		worm_direction_type_id = worm_direction_get_type_once ();
		g_once_init_leave (&worm_direction_type_id__once, worm_direction_type_id);
	}
	return worm_direction_type_id__once;
}

void
position_move (Position *self,
               WormDirection direction,
               guint8 width,
               guint8 height)
{
	switch (direction) {
		case WORM_DIRECTION_UP:
		{
			if (((gint) (*self).y) == 0) {
				(*self).y = (guint8) (height - 1);
			} else {
				guint8 _tmp0_;
				_tmp0_ = (*self).y;
				(*self).y = _tmp0_ - 1;
			}
			break;
		}
		case WORM_DIRECTION_DOWN:
		{
			if (((gint) (*self).y) >= (height - 1)) {
				(*self).y = (guint8) 0;
			} else {
				guint8 _tmp1_;
				_tmp1_ = (*self).y;
				(*self).y = _tmp1_ + 1;
			}
			break;
		}
		case WORM_DIRECTION_LEFT:
		{
			if (((gint) (*self).x) == 0) {
				(*self).x = (guint8) (width - 1);
			} else {
				guint8 _tmp2_;
				_tmp2_ = (*self).x;
				(*self).x = _tmp2_ - 1;
			}
			break;
		}
		case WORM_DIRECTION_RIGHT:
		{
			if (((gint) (*self).x) >= (width - 1)) {
				(*self).x = (guint8) 0;
			} else {
				guint8 _tmp3_;
				_tmp3_ = (*self).x;
				(*self).x = _tmp3_ + 1;
			}
			break;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

Position*
position_dup (const Position* self)
{
	Position* dup;
	dup = g_new0 (Position, 1);
	memcpy (dup, self, sizeof (Position));
	return dup;
}

void
position_free (Position* self)
{
	g_free (self);
}

static GType
position_get_type_once (void)
{
	GType position_type_id;
	position_type_id = g_boxed_type_register_static ("Position", (GBoxedCopyFunc) position_dup, (GBoxedFreeFunc) position_free);
	return position_type_id;
}

GType
position_get_type (void)
{
	static volatile gsize position_type_id__once = 0;
	if (g_once_init_enter (&position_type_id__once)) {
		GType position_type_id;
		position_type_id = position_get_type_once ();
		g_once_init_leave (&position_type_id__once, position_type_id);
	}
	return position_type_id__once;
}

static inline gpointer
worm_properties_get_instance_private (WormProperties* self)
{
	return G_STRUCT_MEMBER_P (self, WormProperties_private_offset);
}

WormProperties*
worm_properties_construct (GType object_type)
{
	WormProperties * self = NULL;
	self = (WormProperties*) g_object_new (object_type, NULL);
	return self;
}

WormProperties*
worm_properties_new (void)
{
	return worm_properties_construct (TYPE_WORM_PROPERTIES);
}

gint
worm_properties_get_color (WormProperties* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_color;
	return result;
}

void
worm_properties_set_color (WormProperties* self,
                           gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_properties_get_color (self);
	if (old_value != value) {
		self->priv->_color = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY]);
	}
}

guint
worm_properties_get_up (WormProperties* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_up;
	return result;
}

void
worm_properties_set_up (WormProperties* self,
                        guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_properties_get_up (self);
	if (old_value != value) {
		self->priv->_up = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY]);
	}
}

guint
worm_properties_get_down (WormProperties* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_down;
	return result;
}

void
worm_properties_set_down (WormProperties* self,
                          guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_properties_get_down (self);
	if (old_value != value) {
		self->priv->_down = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY]);
	}
}

guint
worm_properties_get_left (WormProperties* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_left;
	return result;
}

void
worm_properties_set_left (WormProperties* self,
                          guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_properties_get_left (self);
	if (old_value != value) {
		self->priv->_left = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY]);
	}
}

guint
worm_properties_get_right (WormProperties* self)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_right;
	return result;
}

void
worm_properties_set_right (WormProperties* self,
                           guint value)
{
	guint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_properties_get_right (self);
	if (old_value != value) {
		self->priv->_right = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY]);
	}
}

static void
worm_properties_class_init (WormPropertiesClass * klass,
                            gpointer klass_data)
{
	worm_properties_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &WormProperties_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_properties_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_properties_set_property;
	G_OBJECT_CLASS (klass)->finalize = worm_properties_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_COLOR_PROPERTY, worm_properties_properties[WORM_PROPERTIES_COLOR_PROPERTY] = g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_UP_PROPERTY, worm_properties_properties[WORM_PROPERTIES_UP_PROPERTY] = g_param_spec_uint ("up", "up", "up", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_DOWN_PROPERTY, worm_properties_properties[WORM_PROPERTIES_DOWN_PROPERTY] = g_param_spec_uint ("down", "down", "down", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_LEFT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_LEFT_PROPERTY] = g_param_spec_uint ("left", "left", "left", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_PROPERTIES_RIGHT_PROPERTY, worm_properties_properties[WORM_PROPERTIES_RIGHT_PROPERTY] = g_param_spec_uint ("right", "right", "right", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
worm_properties_instance_init (WormProperties * self,
                               gpointer klass)
{
	self->priv = worm_properties_get_instance_private (self);
}

static void
worm_properties_finalize (GObject * obj)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM_PROPERTIES, WormProperties);
	G_OBJECT_CLASS (worm_properties_parent_class)->finalize (obj);
}

static GType
worm_properties_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WormProperties), 0, (GInstanceInitFunc) worm_properties_instance_init, NULL };
	GType worm_properties_type_id;
	worm_properties_type_id = g_type_register_static (G_TYPE_OBJECT, "WormProperties", &g_define_type_info, 0);
	WormProperties_private_offset = g_type_add_instance_private (worm_properties_type_id, sizeof (WormPropertiesPrivate));
	return worm_properties_type_id;
}

GType
worm_properties_get_type (void)
{
	static volatile gsize worm_properties_type_id__once = 0;
	if (g_once_init_enter (&worm_properties_type_id__once)) {
		GType worm_properties_type_id;
		worm_properties_type_id = worm_properties_get_type_once ();
		g_once_init_leave (&worm_properties_type_id__once, worm_properties_type_id);
	}
	return worm_properties_type_id__once;
}

static void
_vala_worm_properties_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
	switch (property_id) {
		case WORM_PROPERTIES_COLOR_PROPERTY:
		g_value_set_int (value, worm_properties_get_color (self));
		break;
		case WORM_PROPERTIES_UP_PROPERTY:
		g_value_set_uint (value, worm_properties_get_up (self));
		break;
		case WORM_PROPERTIES_DOWN_PROPERTY:
		g_value_set_uint (value, worm_properties_get_down (self));
		break;
		case WORM_PROPERTIES_LEFT_PROPERTY:
		g_value_set_uint (value, worm_properties_get_left (self));
		break;
		case WORM_PROPERTIES_RIGHT_PROPERTY:
		g_value_set_uint (value, worm_properties_get_right (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_worm_properties_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	WormProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM_PROPERTIES, WormProperties);
	switch (property_id) {
		case WORM_PROPERTIES_COLOR_PROPERTY:
		worm_properties_set_color (self, g_value_get_int (value));
		break;
		case WORM_PROPERTIES_UP_PROPERTY:
		worm_properties_set_up (self, g_value_get_uint (value));
		break;
		case WORM_PROPERTIES_DOWN_PROPERTY:
		worm_properties_set_down (self, g_value_get_uint (value));
		break;
		case WORM_PROPERTIES_LEFT_PROPERTY:
		worm_properties_set_left (self, g_value_get_uint (value));
		break;
		case WORM_PROPERTIES_RIGHT_PROPERTY:
		worm_properties_set_right (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
worm_get_instance_private (Worm* self)
{
	return G_STRUCT_MEMBER_P (self, Worm_private_offset);
}

Worm*
worm_construct (GType object_type,
                gint id,
                guint8 width,
                guint8 height)
{
	Worm * self = NULL;
	gint capacity = 0;
	capacity = (gint) (width * height);
	self = (Worm*) g_object_new (object_type, "id", id, "width", width, "height", height, "capacity", capacity, NULL);
	return self;
}

Worm*
worm_new (gint id,
          guint8 width,
          guint8 height)
{
	return worm_construct (TYPE_WORM, id, width, height);
}

void
worm_set_start (Worm* self,
                guint8 x,
                guint8 y,
                WormDirection direction)
{
	GeeLinkedList* _tmp0_;
	Position _tmp1_ = {0};
	GeeLinkedList* _tmp2_;
	Position _tmp3_;
	GeeArrayQueue* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_list;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	memset (&_tmp1_, 0, sizeof (Position));
	_tmp1_.x = x;
	_tmp1_.y = y;
	worm_set_starting_position (self, &_tmp1_);
	_tmp2_ = self->priv->_list;
	_tmp3_ = self->priv->_starting_position;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, &_tmp3_);
	self->priv->starting_direction = direction;
	worm_set_direction (self, direction);
	worm_set_change (self, 0);
	_tmp4_ = self->priv->key_queue;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp4_);
}

void
worm_move_part_1 (Worm* self)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	GeeLinkedList* _tmp5_;
	Position _tmp6_;
	g_return_if_fail (self != NULL);
	if (self->is_human) {
		self->keypress = FALSE;
	}
	worm_get_head (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	position = _tmp1_;
	_tmp2_ = self->priv->_direction;
	_tmp3_ = self->priv->_width;
	_tmp4_ = self->priv->_height;
	position_move (&position, _tmp2_, _tmp3_, _tmp4_);
	_tmp5_ = self->priv->_list;
	_tmp6_ = position;
	gee_deque_offer_head ((GeeDeque*) _tmp5_, &_tmp6_);
}

void
worm_move_part_2 (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  Position* head_position)
{
	gint _tmp1_;
	Position _tmp12_ = {0};
	Position _tmp13_;
	Position _tmp14_ = {0};
	Position _tmp15_;
	gint _tmp16_;
	gboolean _tmp17_;
	GeeArrayQueue* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	g_return_if_fail (self != NULL);
	if (head_position != NULL) {
		Position _tmp0_ = {0};
		memset (&_tmp0_, 0, sizeof (Position));
		_tmp0_.x = (*head_position).x;
		_tmp0_.y = (*head_position).y;
		worm_set_head (self, &_tmp0_);
	}
	_tmp1_ = self->priv->_change;
	if (_tmp1_ > 0) {
		gint _tmp2_;
		_tmp2_ = self->priv->_change;
		worm_set_change (self, _tmp2_ - 1);
		g_signal_emit (self, worm_signals[WORM_ADDED_SIGNAL], 0);
	} else {
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Position* _tmp5_;
		GeeLinkedList* _tmp6_;
		gpointer _tmp7_;
		Position* _tmp8_;
		GeeLinkedList* _tmp9_;
		gpointer _tmp10_;
		Position* _tmp11_;
		_tmp3_ = self->priv->_list;
		_tmp4_ = gee_linked_list_last (_tmp3_);
		_tmp5_ = (Position*) _tmp4_;
		_tmp6_ = self->priv->_list;
		_tmp7_ = gee_linked_list_last (_tmp6_);
		_tmp8_ = (Position*) _tmp7_;
		board[((*_tmp5_).x * board_length2) + (*_tmp8_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
		_position_free0 (_tmp8_);
		_position_free0 (_tmp5_);
		_tmp9_ = self->priv->_list;
		_tmp10_ = gee_deque_poll_tail ((GeeDeque*) _tmp9_);
		_tmp11_ = (Position*) _tmp10_;
		_position_free0 (_tmp11_);
		g_signal_emit (self, worm_signals[WORM_MOVED_SIGNAL], 0);
	}
	worm_get_head (self, &_tmp12_);
	_tmp13_ = _tmp12_;
	worm_get_head (self, &_tmp14_);
	_tmp15_ = _tmp14_;
	_tmp16_ = board[(_tmp13_.x * board_length2) + _tmp15_.y];
	if (_tmp16_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
		g_signal_emit (self, worm_signals[WORM_BONUS_FOUND_SIGNAL], 0);
	}
	_tmp17_ = self->priv->_is_materialized;
	if (_tmp17_) {
		Position _tmp18_ = {0};
		Position _tmp19_;
		Position _tmp20_ = {0};
		Position _tmp21_;
		gint _tmp22_;
		worm_get_head (self, &_tmp18_);
		_tmp19_ = _tmp18_;
		worm_get_head (self, &_tmp20_);
		_tmp21_ = _tmp20_;
		_tmp22_ = self->priv->_id;
		board[(_tmp19_.x * board_length2) + _tmp21_.y] = NIBBLES_GAME_WORMCHAR + _tmp22_;
	} else {
		self->priv->rounds_dematerialized = self->priv->rounds_dematerialized - 1;
	}
	_tmp23_ = self->priv->key_queue;
	_tmp24_ = gee_array_queue_get_is_empty (_tmp23_);
	_tmp25_ = _tmp24_;
	if (!_tmp25_) {
		worm_dequeue_keypress (self);
	}
	if (self->priv->rounds_dematerialized == 1) {
		worm_materialize (self, board, (gint) board_length1, (gint) board_length2);
	}
}

void
worm_reduce_tail (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  gint erase_size)
{
	g_return_if_fail (self != NULL);
	if (erase_size <= 0) {
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				GeeLinkedList* _tmp2_;
				gpointer _tmp3_;
				Position* _tmp4_;
				GeeLinkedList* _tmp5_;
				gpointer _tmp6_;
				Position* _tmp7_;
				GeeLinkedList* _tmp8_;
				gpointer _tmp9_;
				Position* _tmp10_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < erase_size)) {
					break;
				}
				_tmp2_ = self->priv->_list;
				_tmp3_ = gee_linked_list_last (_tmp2_);
				_tmp4_ = (Position*) _tmp3_;
				_tmp5_ = self->priv->_list;
				_tmp6_ = gee_linked_list_last (_tmp5_);
				_tmp7_ = (Position*) _tmp6_;
				board[((*_tmp4_).x * board_length2) + (*_tmp7_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
				_position_free0 (_tmp7_);
				_position_free0 (_tmp4_);
				_tmp8_ = self->priv->_list;
				_tmp9_ = gee_deque_poll_tail ((GeeDeque*) _tmp8_);
				_tmp10_ = (Position*) _tmp9_;
				_position_free0 (_tmp10_);
			}
		}
	}
	g_signal_emit (self, worm_signals[WORM_TAIL_REDUCED_SIGNAL], 0, erase_size);
}

void
worm_reverse (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2)
{
	GeeLinkedList* reversed_list = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* _tmp12_;
	gpointer _tmp13_;
	Position* _tmp14_;
	GeeLinkedList* _tmp15_;
	gpointer _tmp16_;
	Position* _tmp17_;
	gboolean _tmp18_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_linked_list_new (TYPE_POSITION, (GBoxedCopyFunc) position_dup, (GDestroyNotify) position_free, NULL, NULL, NULL);
	reversed_list = _tmp0_;
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _pos_index = 0;
		_tmp1_ = self->priv->_list;
		_pos_list = _tmp1_;
		_tmp2_ = _pos_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_pos_size = _tmp4_;
		_pos_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			Position* pos = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			GeeLinkedList* _tmp9_;
			Position* _tmp10_;
			_pos_index = _pos_index + 1;
			_tmp5_ = _pos_index;
			_tmp6_ = _pos_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _pos_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _pos_index);
			pos = (Position*) _tmp8_;
			_tmp9_ = reversed_list;
			_tmp10_ = pos;
			gee_deque_offer_head ((GeeDeque*) _tmp9_, _tmp10_);
			_position_free0 (pos);
		}
	}
	g_signal_emit (self, worm_signals[WORM_REVERSED_SIGNAL], 0);
	_tmp11_ = reversed_list;
	worm_set_list (self, _tmp11_);
	_tmp12_ = self->priv->_list;
	_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, 0);
	_tmp14_ = (Position*) _tmp13_;
	_tmp15_ = self->priv->_list;
	_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 1);
	_tmp17_ = (Position*) _tmp16_;
	_tmp18_ = (*_tmp14_).y == (*_tmp17_).y;
	_position_free0 (_tmp17_);
	_position_free0 (_tmp14_);
	if (_tmp18_) {
		WormDirection _tmp19_ = 0;
		GeeLinkedList* _tmp20_;
		gpointer _tmp21_;
		Position* _tmp22_;
		GeeLinkedList* _tmp23_;
		gpointer _tmp24_;
		Position* _tmp25_;
		gboolean _tmp26_;
		_tmp20_ = self->priv->_list;
		_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, 0);
		_tmp22_ = (Position*) _tmp21_;
		_tmp23_ = self->priv->_list;
		_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, 1);
		_tmp25_ = (Position*) _tmp24_;
		_tmp26_ = (*_tmp22_).x > (*_tmp25_).x;
		_position_free0 (_tmp25_);
		_position_free0 (_tmp22_);
		if (_tmp26_) {
			_tmp19_ = WORM_DIRECTION_RIGHT;
		} else {
			_tmp19_ = WORM_DIRECTION_LEFT;
		}
		worm_set_direction (self, _tmp19_);
	} else {
		WormDirection _tmp27_ = 0;
		GeeLinkedList* _tmp28_;
		gpointer _tmp29_;
		Position* _tmp30_;
		GeeLinkedList* _tmp31_;
		gpointer _tmp32_;
		Position* _tmp33_;
		gboolean _tmp34_;
		_tmp28_ = self->priv->_list;
		_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, 0);
		_tmp30_ = (Position*) _tmp29_;
		_tmp31_ = self->priv->_list;
		_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, 1);
		_tmp33_ = (Position*) _tmp32_;
		_tmp34_ = (*_tmp30_).y > (*_tmp33_).y;
		_position_free0 (_tmp33_);
		_position_free0 (_tmp30_);
		if (_tmp34_) {
			_tmp27_ = WORM_DIRECTION_DOWN;
		} else {
			_tmp27_ = WORM_DIRECTION_UP;
		}
		worm_set_direction (self, _tmp27_);
	}
	_g_object_unref0 (reversed_list);
}

gboolean
worm_can_move_to (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  gint numworms,
                  Position* position)
{
	gint next_position = 0;
	Position _tmp0_;
	Position _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (position != NULL, FALSE);
	_tmp0_ = *position;
	_tmp1_ = *position;
	_tmp2_ = board[(_tmp0_.x * board_length2) + _tmp1_.y];
	next_position = _tmp2_;
	if (next_position > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
		_tmp3_ = next_position < ((gint) NIBBLES_GAME_WORMCHAR);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		result = FALSE;
		return result;
	}
	if (next_position >= ((gint) NIBBLES_GAME_WORMCHAR)) {
		_tmp4_ = next_position < (NIBBLES_GAME_WORMCHAR + numworms);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gboolean _tmp5_;
		_tmp5_ = self->priv->_is_materialized;
		result = !_tmp5_;
		return result;
	}
	result = TRUE;
	return result;
}

void
worm_spawn (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
	g_return_if_fail (self != NULL);
	worm_set_change (self, WORM_STARTING_LENGTH - 1);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < WORM_STARTING_LENGTH)) {
					break;
				}
				worm_move_part_1 (self);
				worm_move_part_2 (self, board, (gint) board_length1, (gint) board_length2, NULL);
			}
		}
	}
}

static void
worm_materialize (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2)
{
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _pos_index = 0;
		_tmp0_ = self->priv->_list;
		_pos_list = _tmp0_;
		_tmp1_ = _pos_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_pos_size = _tmp3_;
		_pos_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			Position* pos = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Position* _tmp8_;
			Position* _tmp9_;
			gint _tmp10_;
			_pos_index = _pos_index + 1;
			_tmp4_ = _pos_index;
			_tmp5_ = _pos_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _pos_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _pos_index);
			pos = (Position*) _tmp7_;
			_tmp8_ = pos;
			_tmp9_ = pos;
			_tmp10_ = board[((*_tmp8_).x * board_length2) + (*_tmp9_).y];
			if (_tmp10_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				self->priv->rounds_dematerialized = self->priv->rounds_dematerialized + 1;
				_position_free0 (pos);
				return;
			}
			_position_free0 (pos);
		}
	}
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp11_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _pos_index = 0;
		_tmp11_ = self->priv->_list;
		_pos_list = _tmp11_;
		_tmp12_ = _pos_list;
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
		_tmp14_ = _tmp13_;
		_pos_size = _tmp14_;
		_pos_index = -1;
		while (TRUE) {
			gint _tmp15_;
			gint _tmp16_;
			Position* pos = NULL;
			GeeLinkedList* _tmp17_;
			gpointer _tmp18_;
			Position* _tmp19_;
			Position* _tmp20_;
			gint _tmp21_;
			_pos_index = _pos_index + 1;
			_tmp15_ = _pos_index;
			_tmp16_ = _pos_size;
			if (!(_tmp15_ < _tmp16_)) {
				break;
			}
			_tmp17_ = _pos_list;
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _pos_index);
			pos = (Position*) _tmp18_;
			_tmp19_ = pos;
			_tmp20_ = pos;
			_tmp21_ = self->priv->_id;
			board[((*_tmp19_).x * board_length2) + (*_tmp20_).y] = NIBBLES_GAME_WORMCHAR + _tmp21_;
			_position_free0 (pos);
		}
	}
	worm_set_is_materialized (self, TRUE);
	self->priv->rounds_dematerialized = 0;
}

static gboolean
__lambda4_ (Worm* self)
{
	gboolean result;
	self->is_stopped = FALSE;
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((Worm*) self);
	return result;
}

void
worm_dematerialize (Worm* self,
                    gint* board,
                    gint board_length1,
                    gint board_length2,
                    gint rounds,
                    gint gamedelay)
{
	g_return_if_fail (self != NULL);
	self->priv->rounds_dematerialized = rounds;
	worm_set_is_materialized (self, FALSE);
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _pos_index = 0;
		_tmp0_ = self->priv->_list;
		_pos_list = _tmp0_;
		_tmp1_ = _pos_list;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_pos_size = _tmp3_;
		_pos_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			Position* pos = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Position* _tmp8_;
			Position* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_pos_index = _pos_index + 1;
			_tmp4_ = _pos_index;
			_tmp5_ = _pos_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _pos_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _pos_index);
			pos = (Position*) _tmp7_;
			_tmp8_ = pos;
			_tmp9_ = pos;
			_tmp10_ = board[((*_tmp8_).x * board_length2) + (*_tmp9_).y];
			_tmp11_ = self->priv->_id;
			if (_tmp10_ == (NIBBLES_GAME_WORMCHAR + _tmp11_)) {
				Position* _tmp12_;
				Position* _tmp13_;
				_tmp12_ = pos;
				_tmp13_ = pos;
				board[((*_tmp12_).x * board_length2) + (*_tmp13_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
			}
			_position_free0 (pos);
		}
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) (gamedelay * 27), ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
}

void
worm_add_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_lives;
	if (_tmp0_ > WORM_MAX_LIVES) {
		return;
	}
	_tmp1_ = self->priv->_lives;
	worm_set_lives (self, _tmp1_ + 1);
}

static inline void
worm_lose_life (Worm* self)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_lives;
	if (((gint) _tmp0_) == 0) {
		return;
	}
	_tmp1_ = self->priv->_lives;
	worm_set_lives (self, _tmp1_ - 1);
}

void
worm_reset (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
	GeeArrayQueue* _tmp0_;
	GeeLinkedList* _tmp11_;
	GeeLinkedList* _tmp12_;
	Position _tmp13_;
	g_return_if_fail (self != NULL);
	self->is_stopped = TRUE;
	worm_set_is_materialized (self, FALSE);
	self->priv->rounds_dematerialized = 0;
	_tmp0_ = self->priv->key_queue;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	worm_lose_life (self);
	g_signal_emit (self, worm_signals[WORM_DIED_SIGNAL], 0);
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _pos_index = 0;
		_tmp1_ = self->priv->_list;
		_pos_list = _tmp1_;
		_tmp2_ = _pos_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_pos_size = _tmp4_;
		_pos_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			Position* pos = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Position* _tmp9_;
			Position* _tmp10_;
			_pos_index = _pos_index + 1;
			_tmp5_ = _pos_index;
			_tmp6_ = _pos_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _pos_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _pos_index);
			pos = (Position*) _tmp8_;
			_tmp9_ = pos;
			_tmp10_ = pos;
			board[((*_tmp9_).x * board_length2) + (*_tmp10_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
			_position_free0 (pos);
		}
	}
	_tmp11_ = self->priv->_list;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp11_);
	_tmp12_ = self->priv->_list;
	_tmp13_ = self->priv->_starting_position;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, &_tmp13_);
	g_signal_emit (self, worm_signals[WORM_ADDED_SIGNAL], 0);
	worm_set_direction (self, self->priv->starting_direction);
	worm_set_change (self, 0);
	worm_spawn (self, board, (gint) board_length1, (gint) board_length2);
	g_signal_emit (self, worm_signals[WORM_FINISH_ADDED_SIGNAL], 0);
}

void
worm_position_move (Worm* self,
                    Position* result)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	g_return_if_fail (self != NULL);
	worm_get_head (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	position = _tmp1_;
	_tmp2_ = self->priv->_direction;
	_tmp3_ = self->priv->_width;
	_tmp4_ = self->priv->_height;
	position_move (&position, _tmp2_, _tmp3_, _tmp4_);
	*result = position;
	return;
}

static void
worm_direction_set (Worm* self,
                    WormDirection dir)
{
	g_return_if_fail (self != NULL);
	_vala_return_if_fail (dir != WORM_DIRECTION_NONE, "dir != WormDirection.NONE");
	if (!self->is_human) {
		return;
	}
	if (self->keypress) {
		worm_queue_keypress (self, dir);
		return;
	}
	worm_set_direction (self, dir);
	self->keypress = TRUE;
}

static guint
worm_upper_key (Worm* self,
                guint keyval)
{
	guint result;
	g_return_val_if_fail (self != NULL, 0U);
	if (keyval > ((guint) 255)) {
		result = keyval;
		return result;
	}
	result = (guint) g_ascii_toupper ((gchar) keyval);
	return result;
}

gboolean
worm_handle_keypress (Worm* self,
                      guint keyval,
                      GeeHashMap* worm_props)
{
	gboolean _tmp0_ = FALSE;
	guint8 _tmp1_;
	WormProperties* properties = NULL;
	guint propsUp = 0U;
	guint propsDown = 0U;
	guint propsLeft = 0U;
	guint propsRight = 0U;
	guint keyvalUpper = 0U;
	gpointer _tmp2_;
	WormProperties* _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	WormProperties* _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	WormProperties* _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	WormProperties* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (worm_props != NULL, FALSE);
	_tmp1_ = self->priv->_lives;
	if (((gint) _tmp1_) == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->is_stopped;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) worm_props, self);
	_g_object_unref0 (properties);
	properties = (WormProperties*) _tmp2_;
	_tmp3_ = properties;
	_tmp4_ = worm_properties_get_up (_tmp3_);
	_tmp5_ = _tmp4_;
	propsUp = worm_upper_key (self, _tmp5_);
	_tmp6_ = properties;
	_tmp7_ = worm_properties_get_left (_tmp6_);
	_tmp8_ = _tmp7_;
	propsLeft = worm_upper_key (self, _tmp8_);
	_tmp9_ = properties;
	_tmp10_ = worm_properties_get_down (_tmp9_);
	_tmp11_ = _tmp10_;
	propsDown = worm_upper_key (self, _tmp11_);
	_tmp12_ = properties;
	_tmp13_ = worm_properties_get_right (_tmp12_);
	_tmp14_ = _tmp13_;
	propsRight = worm_upper_key (self, _tmp14_);
	keyvalUpper = worm_upper_key (self, keyval);
	if (keyvalUpper == propsUp) {
		WormDirection _tmp16_;
		_tmp16_ = self->priv->_direction;
		_tmp15_ = _tmp16_ != WORM_DIRECTION_DOWN;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		worm_direction_set (self, WORM_DIRECTION_UP);
		result = TRUE;
		_g_object_unref0 (properties);
		return result;
	}
	if (keyvalUpper == propsDown) {
		WormDirection _tmp18_;
		_tmp18_ = self->priv->_direction;
		_tmp17_ = _tmp18_ != WORM_DIRECTION_UP;
	} else {
		_tmp17_ = FALSE;
	}
	if (_tmp17_) {
		worm_direction_set (self, WORM_DIRECTION_DOWN);
		result = TRUE;
		_g_object_unref0 (properties);
		return result;
	}
	if (keyvalUpper == propsRight) {
		WormDirection _tmp20_;
		_tmp20_ = self->priv->_direction;
		_tmp19_ = _tmp20_ != WORM_DIRECTION_LEFT;
	} else {
		_tmp19_ = FALSE;
	}
	if (_tmp19_) {
		worm_direction_set (self, WORM_DIRECTION_RIGHT);
		result = TRUE;
		_g_object_unref0 (properties);
		return result;
	}
	if (keyvalUpper == propsLeft) {
		WormDirection _tmp22_;
		_tmp22_ = self->priv->_direction;
		_tmp21_ = _tmp22_ != WORM_DIRECTION_RIGHT;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		worm_direction_set (self, WORM_DIRECTION_LEFT);
		result = TRUE;
		_g_object_unref0 (properties);
		return result;
	}
	result = FALSE;
	_g_object_unref0 (properties);
	return result;
}

static void
worm_queue_keypress (Worm* self,
                     WormDirection dir)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayQueue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeArrayQueue* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->key_queue;
	_tmp2_ = gee_array_queue_get_is_empty (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		GeeArrayQueue* _tmp4_;
		gpointer _tmp5_;
		_tmp4_ = self->priv->key_queue;
		_tmp5_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp4_);
		_tmp0_ = dir == ((WormDirection) ((gintptr) _tmp5_));
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp6_ = self->priv->key_queue;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, (gpointer) ((gintptr) dir));
}

static void
worm_dequeue_keypress (Worm* self)
{
	GeeArrayQueue* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayQueue* _tmp3_;
	gpointer _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->key_queue;
	_tmp1_ = gee_array_queue_get_is_empty (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_return_if_fail (!_tmp2_, "!key_queue.is_empty");
	_tmp3_ = self->priv->key_queue;
	_tmp4_ = gee_abstract_queue_poll ((GeeAbstractQueue*) _tmp3_);
	worm_direction_set (self, (WormDirection) ((gintptr) _tmp4_));
}

static gint
worm_ai_deadend (gint* board,
                 gint board_length1,
                 gint board_length2,
                 gint numworms,
                 Position* old_position,
                 gint length_left)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	gint result;
	g_return_val_if_fail (old_position != NULL, 0);
	_tmp0_ = board_length1;
	width = (guint8) _tmp0_;
	_tmp1_ = board_length2;
	height = (guint8) _tmp1_;
	if (length_left <= 0) {
		result = 0;
		return result;
	}
	{
		gint dir = 0;
		dir = 4;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				Position new_position = {0};
				Position _tmp4_;
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_ = FALSE;
				Position _tmp7_;
				Position _tmp8_;
				gint _tmp9_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = dir;
					dir = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				if (!(dir > 0)) {
					break;
				}
				_tmp4_ = *old_position;
				new_position = _tmp4_;
				position_move (&new_position, (WormDirection) dir, width, height);
				_tmp7_ = new_position;
				_tmp8_ = new_position;
				_tmp9_ = board[(_tmp7_.x * board_length2) + _tmp8_.y];
				if (_tmp9_ <= ((gint) NIBBLES_GAME_EMPTYCHAR)) {
					_tmp6_ = TRUE;
				} else {
					Position _tmp10_;
					Position _tmp11_;
					gint _tmp12_;
					_tmp10_ = *old_position;
					_tmp11_ = *old_position;
					_tmp12_ = board[(_tmp10_.x * board_length2) + _tmp11_.y];
					_tmp6_ = _tmp12_ >= ('z' + numworms);
				}
				if (_tmp6_) {
					guint* _tmp13_;
					gint _tmp13__length1;
					gint _tmp13__length2;
					Position _tmp14_;
					Position _tmp15_;
					guint _tmp16_;
					_tmp13_ = worm_deadend_board;
					_tmp13__length1 = worm_deadend_board_length1;
					_tmp13__length2 = worm_deadend_board_length2;
					_tmp14_ = new_position;
					_tmp15_ = new_position;
					_tmp16_ = _tmp13_[(_tmp14_.x * _tmp13__length2) + _tmp15_.y];
					_tmp5_ = _tmp16_ != worm_deadend_runnumber;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					guint* _tmp17_;
					gint _tmp17__length1;
					gint _tmp17__length2;
					Position _tmp18_;
					Position _tmp19_;
					Position _tmp20_;
					_tmp17_ = worm_deadend_board;
					_tmp17__length1 = worm_deadend_board_length1;
					_tmp17__length2 = worm_deadend_board_length2;
					_tmp18_ = new_position;
					_tmp19_ = new_position;
					_tmp17_[(_tmp18_.x * _tmp17__length2) + _tmp19_.y] = worm_deadend_runnumber;
					_tmp20_ = new_position;
					length_left = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp20_, length_left - 1);
					if (length_left <= 0) {
						result = 0;
						return result;
					}
				}
			}
		}
	}
	result = length_left;
	return result;
}

static gint
worm_ai_deadend_after (gint* board,
                       gint board_length1,
                       gint board_length2,
                       GeeLinkedList* worms,
                       gint numworms,
                       Position* old_position,
                       WormDirection direction,
                       gint length)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	Position _tmp3_;
	guint _tmp5_;
	Position new_position = {0};
	Position _tmp29_;
	guint* _tmp30_;
	gint _tmp30__length1;
	gint _tmp30__length2;
	Position _tmp31_;
	Position _tmp32_;
	guint* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	Position _tmp34_;
	Position _tmp35_;
	gint cl = 0;
	Position _tmp36_;
	gint result;
	g_return_val_if_fail (worms != NULL, 0);
	g_return_val_if_fail (old_position != NULL, 0);
	_tmp0_ = board_length1;
	width = (guint8) _tmp0_;
	_tmp1_ = board_length2;
	height = (guint8) _tmp1_;
	_tmp3_ = *old_position;
	if (_tmp3_.x >= width) {
		_tmp2_ = TRUE;
	} else {
		Position _tmp4_;
		_tmp4_ = *old_position;
		_tmp2_ = _tmp4_.y >= height;
	}
	if (_tmp2_) {
		result = 0;
		return result;
	}
	_tmp5_ = worm_deadend_runnumber;
	worm_deadend_runnumber = _tmp5_ + 1;
	{
		gint i = 0;
		i = numworms - 1;
		{
			gboolean _tmp6_ = FALSE;
			_tmp6_ = TRUE;
			while (TRUE) {
				guint8 target_x = 0U;
				gpointer _tmp8_;
				Worm* _tmp9_;
				Position _tmp10_ = {0};
				Position _tmp11_;
				guint8 _tmp12_;
				guint8 target_y = 0U;
				gpointer _tmp13_;
				Worm* _tmp14_;
				Position _tmp15_ = {0};
				Position _tmp16_;
				guint8 _tmp17_;
				gboolean _tmp18_ = FALSE;
				Position _tmp19_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ - 1;
				}
				_tmp6_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
				_tmp9_ = (Worm*) _tmp8_;
				worm_get_head (_tmp9_, &_tmp10_);
				_tmp11_ = _tmp10_;
				_tmp12_ = _tmp11_.x;
				_g_object_unref0 (_tmp9_);
				target_x = _tmp12_;
				_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
				_tmp14_ = (Worm*) _tmp13_;
				worm_get_head (_tmp14_, &_tmp15_);
				_tmp16_ = _tmp15_;
				_tmp17_ = _tmp16_.y;
				_g_object_unref0 (_tmp14_);
				target_y = _tmp17_;
				_tmp19_ = *old_position;
				if (target_x == _tmp19_.x) {
					Position _tmp20_;
					_tmp20_ = *old_position;
					_tmp18_ = target_y == _tmp20_.y;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					continue;
				}
				if (((gint) target_x) > 0) {
					guint* _tmp21_;
					gint _tmp21__length1;
					gint _tmp21__length2;
					_tmp21_ = worm_deadend_board;
					_tmp21__length1 = worm_deadend_board_length1;
					_tmp21__length2 = worm_deadend_board_length2;
					_tmp21_[((target_x - 1) * _tmp21__length2) + target_y] = worm_deadend_runnumber;
				} else {
					guint* _tmp22_;
					gint _tmp22__length1;
					gint _tmp22__length2;
					_tmp22_ = worm_deadend_board;
					_tmp22__length1 = worm_deadend_board_length1;
					_tmp22__length2 = worm_deadend_board_length2;
					_tmp22_[((width - 1) * _tmp22__length2) + target_y] = worm_deadend_runnumber;
				}
				if (((gint) target_y) > 0) {
					guint* _tmp23_;
					gint _tmp23__length1;
					gint _tmp23__length2;
					_tmp23_ = worm_deadend_board;
					_tmp23__length1 = worm_deadend_board_length1;
					_tmp23__length2 = worm_deadend_board_length2;
					_tmp23_[(target_x * _tmp23__length2) + (target_y - 1)] = worm_deadend_runnumber;
				} else {
					guint* _tmp24_;
					gint _tmp24__length1;
					gint _tmp24__length2;
					_tmp24_ = worm_deadend_board;
					_tmp24__length1 = worm_deadend_board_length1;
					_tmp24__length2 = worm_deadend_board_length2;
					_tmp24_[(target_x * _tmp24__length2) + (height - 1)] = worm_deadend_runnumber;
				}
				if (((gint) target_x) < (width - 1)) {
					guint* _tmp25_;
					gint _tmp25__length1;
					gint _tmp25__length2;
					_tmp25_ = worm_deadend_board;
					_tmp25__length1 = worm_deadend_board_length1;
					_tmp25__length2 = worm_deadend_board_length2;
					_tmp25_[((target_x + 1) * _tmp25__length2) + target_y] = worm_deadend_runnumber;
				} else {
					guint* _tmp26_;
					gint _tmp26__length1;
					gint _tmp26__length2;
					_tmp26_ = worm_deadend_board;
					_tmp26__length1 = worm_deadend_board_length1;
					_tmp26__length2 = worm_deadend_board_length2;
					_tmp26_[(0 * _tmp26__length2) + target_y] = worm_deadend_runnumber;
				}
				if (((gint) target_y) < (height - 1)) {
					guint* _tmp27_;
					gint _tmp27__length1;
					gint _tmp27__length2;
					_tmp27_ = worm_deadend_board;
					_tmp27__length1 = worm_deadend_board_length1;
					_tmp27__length2 = worm_deadend_board_length2;
					_tmp27_[(target_x * _tmp27__length2) + (target_y + 1)] = worm_deadend_runnumber;
				} else {
					guint* _tmp28_;
					gint _tmp28__length1;
					gint _tmp28__length2;
					_tmp28_ = worm_deadend_board;
					_tmp28__length1 = worm_deadend_board_length1;
					_tmp28__length2 = worm_deadend_board_length2;
					_tmp28_[(target_x * _tmp28__length2) + 0] = worm_deadend_runnumber;
				}
			}
		}
	}
	_tmp29_ = *old_position;
	new_position = _tmp29_;
	position_move (&new_position, direction, width, height);
	_tmp30_ = worm_deadend_board;
	_tmp30__length1 = worm_deadend_board_length1;
	_tmp30__length2 = worm_deadend_board_length2;
	_tmp31_ = *old_position;
	_tmp32_ = *old_position;
	_tmp30_[(_tmp31_.x * _tmp30__length2) + _tmp32_.y] = worm_deadend_runnumber;
	_tmp33_ = worm_deadend_board;
	_tmp33__length1 = worm_deadend_board_length1;
	_tmp33__length2 = worm_deadend_board_length2;
	_tmp34_ = new_position;
	_tmp35_ = new_position;
	_tmp33_[(_tmp34_.x * _tmp33__length2) + _tmp35_.y] = worm_deadend_runnumber;
	cl = (length * length) / 16;
	if (cl < ((gint) width)) {
		cl = (gint) width;
	}
	_tmp36_ = new_position;
	result = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp36_, cl);
	return result;
}

static inline gboolean
worm_ai_too_close (Worm* self,
                   GeeLinkedList* worms)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (worms != NULL, FALSE);
	{
		GeeLinkedList* _worm_list = NULL;
		gint _worm_size = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _worm_index = 0;
		_worm_list = worms;
		_tmp0_ = _worm_list;
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
		_tmp2_ = _tmp1_;
		_worm_size = _tmp2_;
		_worm_index = -1;
		while (TRUE) {
			gint _tmp3_;
			gint _tmp4_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			Worm* _tmp7_;
			gint16 dx = 0;
			Position _tmp8_ = {0};
			Position _tmp9_;
			Worm* _tmp10_;
			Position _tmp11_ = {0};
			Position _tmp12_;
			gint16 dy = 0;
			Position _tmp13_ = {0};
			Position _tmp14_;
			Worm* _tmp15_;
			Position _tmp16_ = {0};
			Position _tmp17_;
			WormDirection _tmp18_;
			_worm_index = _worm_index + 1;
			_tmp3_ = _worm_index;
			_tmp4_ = _worm_size;
			if (!(_tmp3_ < _tmp4_)) {
				break;
			}
			_tmp5_ = _worm_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _worm_index);
			worm = (Worm*) _tmp6_;
			_tmp7_ = worm;
			if (_tmp7_ == self) {
				_g_object_unref0 (worm);
				continue;
			}
			worm_get_head (self, &_tmp8_);
			_tmp9_ = _tmp8_;
			_tmp10_ = worm;
			worm_get_head (_tmp10_, &_tmp11_);
			_tmp12_ = _tmp11_;
			dx = ((gint16) _tmp9_.x) - ((gint16) _tmp12_.x);
			worm_get_head (self, &_tmp13_);
			_tmp14_ = _tmp13_;
			_tmp15_ = worm;
			worm_get_head (_tmp15_, &_tmp16_);
			_tmp17_ = _tmp16_;
			dy = ((gint16) _tmp14_.y) - ((gint16) _tmp17_.y);
			_tmp18_ = self->priv->_direction;
			switch (_tmp18_) {
				case WORM_DIRECTION_UP:
				{
					gboolean _tmp19_ = FALSE;
					gboolean _tmp20_ = FALSE;
					gboolean _tmp21_ = FALSE;
					if (((gint) dy) > 0) {
						_tmp21_ = ((gint) dy) <= 3;
					} else {
						_tmp21_ = FALSE;
					}
					if (_tmp21_) {
						_tmp20_ = ((gint) dx) >= -1;
					} else {
						_tmp20_ = FALSE;
					}
					if (_tmp20_) {
						_tmp19_ = ((gint) dx) <= 1;
					} else {
						_tmp19_ = FALSE;
					}
					if (_tmp19_) {
						result = TRUE;
						_g_object_unref0 (worm);
						return result;
					}
					break;
				}
				case WORM_DIRECTION_DOWN:
				{
					gboolean _tmp22_ = FALSE;
					gboolean _tmp23_ = FALSE;
					gboolean _tmp24_ = FALSE;
					if (((gint) dy) < 0) {
						_tmp24_ = ((gint) dy) >= -3;
					} else {
						_tmp24_ = FALSE;
					}
					if (_tmp24_) {
						_tmp23_ = ((gint) dx) >= -1;
					} else {
						_tmp23_ = FALSE;
					}
					if (_tmp23_) {
						_tmp22_ = ((gint) dx) <= 1;
					} else {
						_tmp22_ = FALSE;
					}
					if (_tmp22_) {
						result = TRUE;
						_g_object_unref0 (worm);
						return result;
					}
					break;
				}
				case WORM_DIRECTION_LEFT:
				{
					gboolean _tmp25_ = FALSE;
					gboolean _tmp26_ = FALSE;
					gboolean _tmp27_ = FALSE;
					if (((gint) dx) > 0) {
						_tmp27_ = ((gint) dx) <= 3;
					} else {
						_tmp27_ = FALSE;
					}
					if (_tmp27_) {
						_tmp26_ = ((gint) dy) >= -1;
					} else {
						_tmp26_ = FALSE;
					}
					if (_tmp26_) {
						_tmp25_ = ((gint) dy) <= 1;
					} else {
						_tmp25_ = FALSE;
					}
					if (_tmp25_) {
						result = TRUE;
						_g_object_unref0 (worm);
						return result;
					}
					break;
				}
				case WORM_DIRECTION_RIGHT:
				{
					gboolean _tmp28_ = FALSE;
					gboolean _tmp29_ = FALSE;
					gboolean _tmp30_ = FALSE;
					if (((gint) dx) < 0) {
						_tmp30_ = ((gint) dx) >= -3;
					} else {
						_tmp30_ = FALSE;
					}
					if (_tmp30_) {
						_tmp29_ = ((gint) dy) >= -1;
					} else {
						_tmp29_ = FALSE;
					}
					if (_tmp29_) {
						_tmp28_ = ((gint) dy) <= 1;
					} else {
						_tmp28_ = FALSE;
					}
					if (_tmp28_) {
						result = TRUE;
						_g_object_unref0 (worm);
						return result;
					}
					break;
				}
				default:
				{
					g_assert_not_reached ();
				}
			}
			_g_object_unref0 (worm);
		}
	}
	result = FALSE;
	return result;
}

static gboolean
worm_ai_wander (gint* board,
                gint board_length1,
                gint board_length2,
                gint numworms,
                Position* updated_position,
                WormDirection direction,
                Position* initial_position)
{
	guint8 width = 0U;
	gint _tmp0_;
	guint8 height = 0U;
	gint _tmp1_;
	Position _tmp2_;
	Position _tmp3_;
	gint _tmp4_;
	gboolean result;
	g_return_val_if_fail (updated_position != NULL, FALSE);
	g_return_val_if_fail (initial_position != NULL, FALSE);
	_tmp0_ = board_length1;
	width = (guint8) _tmp0_;
	_tmp1_ = board_length2;
	height = (guint8) _tmp1_;
	position_move (updated_position, direction, width, height);
	_tmp2_ = *updated_position;
	_tmp3_ = *updated_position;
	_tmp4_ = board[(_tmp2_.x * board_length2) + _tmp3_.y];
	switch (_tmp4_ - 'A') {
		case BONUS_TYPE_REGULAR:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_DOUBLE:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_LIFE:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_REVERSE:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_HALF:
		{
			result = FALSE;
			return result;
		}
		default:
		{
			gboolean _tmp5_ = FALSE;
			Position _tmp6_;
			Position _tmp7_;
			gint _tmp8_;
			gboolean _tmp12_ = FALSE;
			Position _tmp13_;
			Position _tmp14_;
			Position _tmp17_;
			Position _tmp18_;
			_tmp6_ = *updated_position;
			_tmp7_ = *updated_position;
			_tmp8_ = board[(_tmp6_.x * board_length2) + _tmp7_.y];
			if (_tmp8_ > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				Position _tmp9_;
				Position _tmp10_;
				gint _tmp11_;
				_tmp9_ = *updated_position;
				_tmp10_ = *updated_position;
				_tmp11_ = board[(_tmp9_.x * board_length2) + _tmp10_.y];
				_tmp5_ = _tmp11_ < ('z' + numworms);
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				result = FALSE;
				return result;
			}
			_tmp13_ = *updated_position;
			_tmp14_ = *initial_position;
			if (_tmp13_.x == _tmp14_.x) {
				Position _tmp15_;
				Position _tmp16_;
				_tmp15_ = *updated_position;
				_tmp16_ = *initial_position;
				_tmp12_ = _tmp15_.y == _tmp16_.y;
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				result = FALSE;
				return result;
			}
			_tmp17_ = *updated_position;
			_tmp18_ = *initial_position;
			result = worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp17_, direction, &_tmp18_);
			return result;
		}
	}
}

void
worm_ai_move (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2,
              gint numworms,
              GeeLinkedList* worms)
{
	WormDirection opposite = 0;
	WormDirection _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
	WormDirection _tmp3_;
	Position _tmp4_ = {0};
	Position _tmp5_;
	WormDirection prev_dir = 0;
	WormDirection _tmp21_;
	WormDirection best_dir = 0;
	gint best_yet = 0;
	gint _tmp22_;
	gint this_len = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (worms != NULL);
	_tmp0_ = self->priv->_direction;
	opposite = worm_direction_opposite (_tmp0_);
	worm_get_head (self, &_tmp1_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->_direction;
	worm_get_head (self, &_tmp4_);
	_tmp5_ = _tmp4_;
	if (!worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp2_, _tmp3_, &_tmp5_)) {
		Position _tmp6_ = {0};
		Position _tmp7_;
		WormDirection _tmp8_;
		Position _tmp9_ = {0};
		Position _tmp10_;
		worm_get_head (self, &_tmp6_);
		_tmp7_ = _tmp6_;
		_tmp8_ = self->priv->_direction;
		worm_get_head (self, &_tmp9_);
		_tmp10_ = _tmp9_;
		if (worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp7_, worm_direction_turn_left (_tmp8_), &_tmp10_)) {
			WormDirection _tmp11_;
			_tmp11_ = self->priv->_direction;
			worm_set_direction (self, worm_direction_turn_left (_tmp11_));
		} else {
			Position _tmp12_ = {0};
			Position _tmp13_;
			WormDirection _tmp14_;
			Position _tmp15_ = {0};
			Position _tmp16_;
			worm_get_head (self, &_tmp12_);
			_tmp13_ = _tmp12_;
			_tmp14_ = self->priv->_direction;
			worm_get_head (self, &_tmp15_);
			_tmp16_ = _tmp15_;
			if (worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, &_tmp13_, worm_direction_turn_right (_tmp14_), &_tmp16_)) {
				WormDirection _tmp17_;
				_tmp17_ = self->priv->_direction;
				worm_set_direction (self, worm_direction_turn_right (_tmp17_));
			} else {
				if (g_random_int_range ((gint32) 0, (gint32) 30) == ((gint32) 1)) {
					WormDirection _tmp18_ = 0;
					if (g_random_boolean ()) {
						WormDirection _tmp19_;
						_tmp19_ = self->priv->_direction;
						_tmp18_ = worm_direction_turn_right (_tmp19_);
					} else {
						WormDirection _tmp20_;
						_tmp20_ = self->priv->_direction;
						_tmp18_ = worm_direction_turn_left (_tmp20_);
					}
					worm_set_direction (self, _tmp18_);
				}
			}
		}
	}
	_tmp21_ = self->priv->_direction;
	prev_dir = _tmp21_;
	best_dir = WORM_DIRECTION_NONE;
	_tmp22_ = self->priv->_capacity;
	best_yet = _tmp22_ * 2;
	{
		gint dir = 0;
		dir = 1;
		{
			gboolean _tmp23_ = FALSE;
			_tmp23_ = TRUE;
			while (TRUE) {
				WormDirection _tmp25_;
				Position _tmp26_ = {0};
				Position _tmp28_ = {0};
				Position _tmp29_;
				WormDirection _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
				gboolean _tmp34_ = FALSE;
				WormDirection _tmp35_;
				if (!_tmp23_) {
					gint _tmp24_;
					_tmp24_ = dir;
					dir = _tmp24_ + 1;
				}
				_tmp23_ = FALSE;
				if (!(dir <= 4)) {
					break;
				}
				worm_set_direction (self, (WormDirection) dir);
				_tmp25_ = self->priv->_direction;
				if (_tmp25_ == opposite) {
					continue;
				}
				this_len = 0;
				worm_position_move (self, &_tmp26_);
				if (!worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, numworms, &_tmp26_)) {
					gint _tmp27_;
					_tmp27_ = self->priv->_capacity;
					this_len += _tmp27_;
				}
				if (worm_ai_too_close (self, worms)) {
					this_len += 4;
				}
				worm_get_head (self, &_tmp28_);
				_tmp29_ = _tmp28_;
				_tmp30_ = self->priv->_direction;
				_tmp31_ = worm_get_length (self);
				_tmp32_ = _tmp31_;
				_tmp33_ = self->priv->_change;
				this_len += worm_ai_deadend_after (board, (gint) board_length1, (gint) board_length2, worms, numworms, &_tmp29_, _tmp30_, _tmp32_ + _tmp33_);
				_tmp35_ = self->priv->_direction;
				if (_tmp35_ == prev_dir) {
					_tmp34_ = this_len <= 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					this_len -= 100;
				}
				if (this_len <= 0) {
					this_len -= (gint) g_random_int_range ((gint32) 0, (gint32) 100);
				}
				if (this_len < best_yet) {
					WormDirection _tmp36_;
					best_yet = this_len;
					_tmp36_ = self->priv->_direction;
					best_dir = _tmp36_;
				}
			}
		}
	}
	if (best_dir == WORM_DIRECTION_NONE) {
		g_assert_not_reached ();
	}
	worm_set_direction (self, best_dir);
	{
		guint8 dir = 0U;
		dir = (guint8) 1;
		{
			gboolean _tmp37_ = FALSE;
			_tmp37_ = TRUE;
			while (TRUE) {
				Position _tmp39_ = {0};
				if (!_tmp37_) {
					guint8 _tmp38_;
					_tmp38_ = dir;
					dir = _tmp38_ + 1;
				}
				_tmp37_ = FALSE;
				if (!(((gint) dir) <= 4)) {
					break;
				}
				if (opposite == ((WormDirection) dir)) {
					continue;
				}
				worm_position_move (self, &_tmp39_);
				if (!worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, numworms, &_tmp39_)) {
					worm_set_direction (self, (WormDirection) dir);
				}
			}
		}
	}
}

void
worm_get_starting_position (Worm* self,
                            Position * result)
{
	Position _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_starting_position;
	*result = _tmp0_;
	return;
}

static gboolean
_position_equal (const Position * s1,
                 const Position * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->x != s2->x) {
		return FALSE;
	}
	if (s1->y != s2->y) {
		return FALSE;
	}
	return TRUE;
}

static void
worm_set_starting_position (Worm* self,
                            Position * value)
{
	Position old_value;
	g_return_if_fail (self != NULL);
	worm_get_starting_position (self, &old_value);
	if (_position_equal (value, &old_value) != TRUE) {
		Position _tmp0_;
		_tmp0_ = *value;
		self->priv->_starting_position = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_STARTING_POSITION_PROPERTY]);
	}
}

gint
worm_get_id (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_id;
	return result;
}

static void
worm_set_id (Worm* self,
             gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_id (self);
	if (old_value != value) {
		self->priv->_id = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_ID_PROPERTY]);
	}
}

gboolean
worm_get_is_materialized (Worm* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_materialized;
	return result;
}

static void
worm_set_is_materialized (Worm* self,
                          gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_is_materialized (self);
	if (old_value != value) {
		self->priv->_is_materialized = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_IS_MATERIALIZED_PROPERTY]);
	}
}

guint8
worm_get_lives (Worm* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_lives;
	return result;
}

void
worm_set_lives (Worm* self,
                guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_lives (self);
	if (old_value != value) {
		self->priv->_lives = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIVES_PROPERTY]);
	}
}

gint
worm_get_change (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_change;
	return result;
}

void
worm_set_change (Worm* self,
                 gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_change (self);
	if (old_value != value) {
		self->priv->_change = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CHANGE_PROPERTY]);
	}
}

gint
worm_get_score (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_score;
	return result;
}

void
worm_set_score (Worm* self,
                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_score (self);
	if (old_value != value) {
		self->priv->_score = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_SCORE_PROPERTY]);
	}
}

gint
worm_get_length (Worm* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_list;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
worm_get_head (Worm* self,
               Position * result)
{
	Position head = {0};
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	Position* _tmp2_;
	Position _tmp3_;
	Position _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_list;
	_tmp1_ = gee_linked_list_first (_tmp0_);
	_tmp2_ = (Position*) _tmp1_;
	_tmp3_ = *_tmp2_;
	_position_free0 (_tmp2_);
	head = _tmp3_;
	_tmp4_ = head;
	*result = _tmp4_;
	return;
}

static void
worm_set_head (Worm* self,
               Position * value)
{
	GeeLinkedList* _tmp0_;
	Position _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_list;
	_tmp1_ = *value;
	gee_abstract_list_set ((GeeAbstractList*) _tmp0_, 0, &_tmp1_);
	g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEAD_PROPERTY]);
}

WormDirection
worm_get_direction (Worm* self)
{
	WormDirection result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_direction;
	return result;
}

static void
worm_set_direction (Worm* self,
                    WormDirection value)
{
	WormDirection old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_direction (self);
	if (old_value != value) {
		self->priv->_direction = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_DIRECTION_PROPERTY]);
	}
}

GeeLinkedList*
worm_get_list (Worm* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
worm_set_list (Worm* self,
               GeeLinkedList* value)
{
	GeeLinkedList* old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_list (self);
	if (old_value != value) {
		GeeLinkedList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_list);
		self->priv->_list = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIST_PROPERTY]);
	}
}

static guint8
worm_get_width (Worm* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_width;
	return result;
}

static void
worm_set_width (Worm* self,
                guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_width (self);
	if (old_value != value) {
		self->priv->_width = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_WIDTH_PROPERTY]);
	}
}

static guint8
worm_get_height (Worm* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_height;
	return result;
}

static void
worm_set_height (Worm* self,
                 guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_height (self);
	if (old_value != value) {
		self->priv->_height = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEIGHT_PROPERTY]);
	}
}

static gint
worm_get_capacity (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_capacity;
	return result;
}

static void
worm_set_capacity (Worm* self,
                   gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = worm_get_capacity (self);
	if (old_value != value) {
		self->priv->_capacity = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_CAPACITY_PROPERTY]);
	}
}

static GObject *
worm_constructor (GType type,
                  guint n_construct_properties,
                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Worm * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint* _tmp2_;
	parent_class = G_OBJECT_CLASS (worm_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
	_tmp0_ = self->priv->_width;
	_tmp1_ = self->priv->_height;
	_tmp2_ = g_new0 (guint, _tmp0_ * _tmp1_);
	worm_deadend_board = (g_free (worm_deadend_board), NULL);
	worm_deadend_board = _tmp2_;
	worm_deadend_board_length1 = _tmp0_;
	worm_deadend_board_length2 = _tmp1_;
	return obj;
}

static void
worm_class_init (WormClass * klass,
                 gpointer klass_data)
{
	worm_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Worm_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_set_property;
	G_OBJECT_CLASS (klass)->constructor = worm_constructor;
	G_OBJECT_CLASS (klass)->finalize = worm_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_STARTING_POSITION_PROPERTY, worm_properties[WORM_STARTING_POSITION_PROPERTY] = g_param_spec_boxed ("starting-position", "starting-position", "starting-position", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_ID_PROPERTY, worm_properties[WORM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_IS_MATERIALIZED_PROPERTY, worm_properties[WORM_IS_MATERIALIZED_PROPERTY] = g_param_spec_boolean ("is-materialized", "is-materialized", "is-materialized", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIVES_PROPERTY, worm_properties[WORM_LIVES_PROPERTY] = g_param_spec_uchar ("lives", "lives", "lives", 0, G_MAXUINT8, WORM_STARTING_LIVES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CHANGE_PROPERTY, worm_properties[WORM_CHANGE_PROPERTY] = g_param_spec_int ("change", "change", "change", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_SCORE_PROPERTY, worm_properties[WORM_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LENGTH_PROPERTY, worm_properties[WORM_LENGTH_PROPERTY] = g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEAD_PROPERTY, worm_properties[WORM_HEAD_PROPERTY] = g_param_spec_boxed ("head", "head", "head", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_DIRECTION_PROPERTY, worm_properties[WORM_DIRECTION_PROPERTY] = g_param_spec_enum ("direction", "direction", "direction", TYPE_WORM_DIRECTION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIST_PROPERTY, worm_properties[WORM_LIST_PROPERTY] = g_param_spec_object ("list", "list", "list", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_WIDTH_PROPERTY, worm_properties[WORM_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEIGHT_PROPERTY, worm_properties[WORM_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_CAPACITY_PROPERTY, worm_properties[WORM_CAPACITY_PROPERTY] = g_param_spec_int ("capacity", "capacity", "capacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	worm_signals[WORM_ADDED_SIGNAL] = g_signal_new ("added", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_FINISH_ADDED_SIGNAL] = g_signal_new ("finish-added", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_RESCALED_SIGNAL] = g_signal_new ("rescaled", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	worm_signals[WORM_DIED_SIGNAL] = g_signal_new ("died", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_TAIL_REDUCED_SIGNAL] = g_signal_new ("tail-reduced", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	worm_signals[WORM_REVERSED_SIGNAL] = g_signal_new ("reversed", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_BONUS_FOUND_SIGNAL] = g_signal_new ("bonus-found", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
worm_instance_init (Worm * self,
                    gpointer klass)
{
	GeeArrayQueue* _tmp0_;
	GeeLinkedList* _tmp1_;
	self->priv = worm_get_instance_private (self);
	self->keypress = FALSE;
	self->is_stopped = FALSE;
	self->priv->_is_materialized = TRUE;
	self->priv->_lives = WORM_STARTING_LIVES;
	self->priv->_change = 0;
	self->priv->_score = 0;
	_tmp0_ = gee_array_queue_new (TYPE_WORM_DIRECTION, NULL, NULL, NULL, NULL, NULL);
	self->priv->key_queue = _tmp0_;
	_tmp1_ = gee_linked_list_new (TYPE_POSITION, (GBoxedCopyFunc) position_dup, (GDestroyNotify) position_free, NULL, NULL, NULL);
	self->priv->_list = _tmp1_;
}

static void
worm_finalize (GObject * obj)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
	_g_object_unref0 (self->priv->key_queue);
	_g_object_unref0 (self->priv->_list);
	G_OBJECT_CLASS (worm_parent_class)->finalize (obj);
}

static GType
worm_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WormClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Worm), 0, (GInstanceInitFunc) worm_instance_init, NULL };
	GType worm_type_id;
	worm_type_id = g_type_register_static (G_TYPE_OBJECT, "Worm", &g_define_type_info, 0);
	Worm_private_offset = g_type_add_instance_private (worm_type_id, sizeof (WormPrivate));
	return worm_type_id;
}

GType
worm_get_type (void)
{
	static volatile gsize worm_type_id__once = 0;
	if (g_once_init_enter (&worm_type_id__once)) {
		GType worm_type_id;
		worm_type_id = worm_get_type_once ();
		g_once_init_leave (&worm_type_id__once, worm_type_id);
	}
	return worm_type_id__once;
}

static void
_vala_worm_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
	switch (property_id) {
		case WORM_STARTING_POSITION_PROPERTY:
		{
			Position boxed;
			worm_get_starting_position (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case WORM_ID_PROPERTY:
		g_value_set_int (value, worm_get_id (self));
		break;
		case WORM_IS_MATERIALIZED_PROPERTY:
		g_value_set_boolean (value, worm_get_is_materialized (self));
		break;
		case WORM_LIVES_PROPERTY:
		g_value_set_uchar (value, worm_get_lives (self));
		break;
		case WORM_CHANGE_PROPERTY:
		g_value_set_int (value, worm_get_change (self));
		break;
		case WORM_SCORE_PROPERTY:
		g_value_set_int (value, worm_get_score (self));
		break;
		case WORM_LENGTH_PROPERTY:
		g_value_set_int (value, worm_get_length (self));
		break;
		case WORM_HEAD_PROPERTY:
		{
			Position boxed;
			worm_get_head (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case WORM_DIRECTION_PROPERTY:
		g_value_set_enum (value, worm_get_direction (self));
		break;
		case WORM_LIST_PROPERTY:
		g_value_set_object (value, worm_get_list (self));
		break;
		case WORM_WIDTH_PROPERTY:
		g_value_set_uchar (value, worm_get_width (self));
		break;
		case WORM_HEIGHT_PROPERTY:
		g_value_set_uchar (value, worm_get_height (self));
		break;
		case WORM_CAPACITY_PROPERTY:
		g_value_set_int (value, worm_get_capacity (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_worm_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
	switch (property_id) {
		case WORM_STARTING_POSITION_PROPERTY:
		worm_set_starting_position (self, g_value_get_boxed (value));
		break;
		case WORM_ID_PROPERTY:
		worm_set_id (self, g_value_get_int (value));
		break;
		case WORM_IS_MATERIALIZED_PROPERTY:
		worm_set_is_materialized (self, g_value_get_boolean (value));
		break;
		case WORM_LIVES_PROPERTY:
		worm_set_lives (self, g_value_get_uchar (value));
		break;
		case WORM_CHANGE_PROPERTY:
		worm_set_change (self, g_value_get_int (value));
		break;
		case WORM_SCORE_PROPERTY:
		worm_set_score (self, g_value_get_int (value));
		break;
		case WORM_HEAD_PROPERTY:
		worm_set_head (self, g_value_get_boxed (value));
		break;
		case WORM_DIRECTION_PROPERTY:
		worm_set_direction (self, g_value_get_enum (value));
		break;
		case WORM_LIST_PROPERTY:
		worm_set_list (self, g_value_get_object (value));
		break;
		case WORM_WIDTH_PROPERTY:
		worm_set_width (self, g_value_get_uchar (value));
		break;
		case WORM_HEIGHT_PROPERTY:
		worm_set_height (self, g_value_get_uchar (value));
		break;
		case WORM_CAPACITY_PROPERTY:
		worm_set_capacity (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

